#include <stdio.h>
#include <conio.h>

// parameter simulation

float anzahl_lebend		= 1000.0 ;
float anzahl_infiziert	=    0.0 ;
float anzahl_gesund		=  997.0 ;
float anzahl_krank		=    3.0 ;
float anzahl_immun		=    0.0 ;
float anzahl_tot		=	 0.0 ;
float anzahl_gestorben	=    0.0 ;
float anzahl_immunisiert =   0.0 ;


// wahrscheinlichkeiten

float wahrscheinlichkeit_infektion	= 0.00075 ;
float wahrscheinlichkeit_laetalitaet= 0.05 ;
float wahrscheinlichkeit_immunitaet = 0.15 ;

// laufvariable

int T = 1;
int DeltaT = 1;

// einfache simulation der ausbreitung einer infektionskrankeit in einer population

int main () 
{
	anzahl_lebend = anzahl_gesund + anzahl_krank + anzahl_immun ;
	printf ("Periode\tLebend\tGesund\tKrank\tImmun\tTot\n") ;
	printf ("-----------------------------------------------------------------------------\n") ;

	while (T < 55)
	{	
		
		// anzeige aktueller zyklus

		printf ("%li\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\n", T, 
				anzahl_lebend, anzahl_gesund, anzahl_krank, anzahl_immun, anzahl_tot ) ;

		// differenzen neu im aktuellen zyklus

		anzahl_infiziert = wahrscheinlichkeit_infektion * (anzahl_gesund * anzahl_krank) ;
		if ( anzahl_infiziert >= anzahl_gesund ) 
		{
			anzahl_infiziert = anzahl_gesund  ;
			getch () ;
		}

		anzahl_immunisiert = wahrscheinlichkeit_immunitaet * anzahl_krank ;

		anzahl_gestorben = wahrscheinlichkeit_laetalitaet * anzahl_krank ;

		// summen neu fr nchsten zyklus

		anzahl_immun += anzahl_immunisiert ;
		if (( anzahl_immun >= anzahl_lebend ))
		{ 
			anzahl_immun = anzahl_lebend ;
			getch () ;
		}

		anzahl_krank	+= anzahl_infiziert ;
		anzahl_krank	-= anzahl_gestorben ;
		anzahl_krank	-= anzahl_immunisiert ;
		if ( anzahl_krank >= anzahl_lebend ) 
		{
			anzahl_krank = anzahl_lebend ;
			getch () ;
		}

		anzahl_gesund	-= anzahl_infiziert ;
	
		anzahl_tot		+= anzahl_gestorben ;

		anzahl_lebend	-= anzahl_gestorben ;

	T = T + DeltaT ;
}

getch () ;
return 0 ;

}